#!/usr/bin/perl
###
$ListLength=255;
###
use DBI;
###
&ReadForm;
&ListAdd if($FORM{cmd} eq 'add');
&ListGet if($FORM{cmd} eq 'get');
###
sub ListAdd{
	my($dbh,$url);
	$url=$FORM{url};
	if($url!~/[\\'"]/ && $url){
		$url=~tr/+/ /;
		$url=~s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("H2",$1)/eg;
		$url=~s/^\s+//;
		$url=~s/\s+$//;
		$dbh=DBI->connect("dbi:SQLite:dbname=../url.db");
		$dbh->do("insert into UrlList(Url) values('$url')");
		$dbh->disconnect;
	}
	print "location:index.html\n\n";
	exit;
}
###
sub ListGet{
	my($dbh,$sth,$ref,$script,$offset,@byte,$tan,$page);
	$page=$FORM{page}||0;
	if(!-s("../url.db")){
		$dbh=DBI->connect("dbi:SQLite:dbname=../url.db");
		$dbh->do("create table UrlList(RowId integer primary key autoincrement,Url text)");
		$dbh->disconnect;
	}
	$offset=$ListLength*$page;
	$dbh=DBI->connect("dbi:SQLite:dbname=../url.db");
	$sth=$dbh->prepare("select RowId,Url from UrlList order by RowId desc limit $ListLength offset $offset");
	$sth->execute;
	while($ref=$sth->fetch){
		$tan=&B64Encode($ref->[0]);
		$script.="," if($script);
		$script.="['$tan','$ref->[1]']";
	}
	$sth->finish;
	$sth=$dbh->prepare("select RowId,Url from UrlList order by RowId desc limit 1 offset ".($offset+$ListLength));
	$sth->execute;
	$next=0;
	if($sth->fetch){
		$next=$page+1;
	}
	$sth->finish;
	$dbh->disconnect;
	$script="List[$page]=[$script];\n";
	$script.="UrlList($page,$next);\n";
	&PrintScript(\$script);
}
###
sub PrintScript{
	print "content-type:application/x-javascript\n\n";
	print ${$_[0]};
	exit;
}
###
sub B64Encode{
	my($in,$out,$table);
	$in=shift;
	$table="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";
	do{
		$out=substr($table,$in%64,1).$out;
		$in=int($in/64);
	}while($in>0);
	return($out);
}
###
sub ReadForm{
	my($form,@item,$key,$value);
	$form=$ENV{'QUERY_STRING'};
	@item=split(/[&]/,$form);
	foreach(@item){
		($key,$value)=$_=~/^([^=]+)=(.*)$/;
		$FORM{$key}=$value;
	}
}
###

